/*
 * exemplo : Expresses Regulares.
 */ 

/*
RegExp : Epsilon   ()
       | Literal   (CHAR)
       | Or        (RegExp RegExp)
       | Then      (RegExp RegExp)
       | Star      (RegExp)
       | Optional  (RegExp)
       | OneOrMore (RegExp)
       ;
*/

# include <stdio.h>
# include <stdlib.h>
# include "Prelude.h"
# include "RegExp.h"
# include "RegExp_cata.h"
# include "RegExp.c"
# include "RegExp_cata.c"


int main(void)
{

  RegExp exemplo = Or(Epsilon()
                     ,Then(Literal('a')
                          ,Star(Literal('b'))
                          )
                     );

  printf("exemplo (show) = %s\n",string_toCStr(show_RegExp(exemplo)));

  free_RegExp (exemplo);
  
  return 0;
};

