%start YYentry

%union {
  lrc_term term_val;
  lrc_string str_val;
}

%token <str_val> gen_id_0
%token <str_val> gen_id_1
%token <str_val> gen_id_2
%token <str_val> gen_id_3
%token <str_val> gen_id_4
%token <str_val> gen_id_5
%token <str_val> gen_id_6
%token <str_val> gen_id_7
%token <str_val> gen_id_8
%token <str_val> gen_id_9
%token <str_val> gen_id_10
%token <str_val> gen_id_11
%token <str_val> gen_id_12
%token <str_val> gen_id_13
%token <str_val> gen_id_14
%token <str_val> gen_id_15
%token <str_val> gen_id_16
%token <str_val> gen_id_17
%token <str_val> gen_id_18
%token <str_val> gen_id_19
%token <str_val> FL_ENTRY
%token <str_val> FL_lElem_ENTRY
%token <str_val> FL_Elem_ENTRY
%token <str_val> FL_Option_ENTRY
%token <str_val> FL_Option_ENTRY
%token <str_val> BOOL_ENTRY
%token <str_val> FL_Nterm_ENTRY
%token <str_val> FL_Cons_ENTRY
%token <str_val> FL_lCons_ENTRY
%token <str_val> FL_lParam_ENTRY
%token <str_val> FL_Param_ENTRY
%token <str_val> FL_PType_ENTRY
%token <str_val> FL_lFType_ENTRY
%token <str_val> FL_FType_ENTRY
%token <str_val> FL_RFType_ENTRY
%type <term_val> YYentry
%type <str_val>WHITESPACE
%type <str_val>s_STR
%type <str_val>s_BOOL
%type <str_val>s_REAL
%type <str_val>s_INT
%type <str_val>s_PTR
%type <str_val>s_CHAR
%type <str_val>s_ANYTYPE
%type <str_val>s_OPTION_TAG
%type <str_val>s_CODE
%type <str_val>s_CODE_OPTIMIZE
%type <str_val>s_CODE_COMMENTS
%type <str_val>s_CODE_CODEWIDTH
%type <str_val>s_YES
%type <str_val>s_NO
%type <str_val>s_NUMBER_INT
%type <str_val>s_IDENT
%type <term_val>parser_FL
%type <term_val>parser_lElem
%type <term_val>parser_Elem
%type <term_val>parser_Option
%type <term_val>parser_CodeOption
%type <term_val>parser_BoolOption
%type <term_val>parser_Nterm
%type <term_val>parser_Sep
%type <term_val>parser_Cons
%type <term_val>parser_lParam
%type <term_val>parser_Param
%type <term_val>parser_PType
%type <term_val>parser_lFType
%type <term_val>parser_FType
%type <term_val>parser_RFType
%%
WHITESPACE : gen_id_0  {$$ = $1; };
WHITESPACE : gen_id_1  {$$ = $1; };
WHITESPACE : gen_id_2  {$$ = $1; };
WHITESPACE : gen_id_3  {$$ = $1; };
s_STR : gen_id_4  {$$ = $1; };
s_BOOL : gen_id_5  {$$ = $1; };
s_REAL : gen_id_6  {$$ = $1; };
s_INT : gen_id_7  {$$ = $1; };
s_PTR : gen_id_8  {$$ = $1; };
s_CHAR : gen_id_9  {$$ = $1; };
s_ANYTYPE : gen_id_10  {$$ = $1; };
s_OPTION_TAG : gen_id_11  {$$ = $1; };
s_CODE : gen_id_12  {$$ = $1; };
s_CODE_OPTIMIZE : gen_id_13  {$$ = $1; };
s_CODE_COMMENTS : gen_id_14  {$$ = $1; };
s_CODE_CODEWIDTH : gen_id_15  {$$ = $1; };
s_YES : gen_id_16  {$$ = $1; };
s_NO : gen_id_17  {$$ = $1; };
s_NUMBER_INT : gen_id_18  {$$ = $1; };
s_IDENT : gen_id_19  {$$ = $1; };
parser_FL : parser_lElem  {$$ = Cgen_id_35(lrc_no_white(),$1,lrc_no_white()); };
parser_lElem : parser_Elem parser_lElem  {$$ = Cgen_id_37(lrc_no_white(),$1,lrc_no_white(),$2,lrc_no_white()); };
parser_lElem :  {$$ = Cgen_id_36(lrc_no_white()); };
parser_Elem : parser_Nterm  {$$ = Cgen_id_39(lrc_no_white(),$1,lrc_no_white()); };
parser_Elem : s_OPTION_TAG parser_Option  {$$ = Cgen_id_38(lrc_no_white(),$1,lrc_no_white(),$2,lrc_no_white()); };
parser_Option : s_CODE parser_CodeOption  {$$ = Cgen_id_40(lrc_no_white(),$1,lrc_no_white(),$2,lrc_no_white()); };
parser_CodeOption : s_CODE_CODEWIDTH '=' s_NUMBER_INT ';'  {$$ = Cgen_id_43(lrc_no_white(),$1,lrc_no_white(),lrc_no_white(),$3,lrc_no_white(),lrc_no_white()); };
parser_CodeOption : s_CODE_COMMENTS '=' parser_BoolOption ';'  {$$ = Cgen_id_42(lrc_no_white(),$1,lrc_no_white(),lrc_no_white(),$3,lrc_no_white(),lrc_no_white()); };
parser_CodeOption : s_CODE_OPTIMIZE '=' parser_BoolOption ';'  {$$ = Cgen_id_41(lrc_no_white(),$1,lrc_no_white(),lrc_no_white(),$3,lrc_no_white(),lrc_no_white()); };
parser_BoolOption : s_NO  {$$ = Cgen_id_45(lrc_no_white(),$1,lrc_no_white()); };
parser_BoolOption : s_YES  {$$ = Cgen_id_44(lrc_no_white(),$1,lrc_no_white()); };
parser_Nterm : s_IDENT ':' parser_Cons parser_Sep  {$$ = Cgen_id_46(lrc_no_white(),$1,lrc_no_white(),lrc_no_white(),$3,lrc_no_white(),$4,lrc_no_white()); };
parser_Sep : '|' parser_Cons parser_Sep  {$$ = Cgen_id_48(lrc_no_white(),lrc_no_white(),$2,lrc_no_white(),$3,lrc_no_white()); };
parser_Sep : ';'  {$$ = Cgen_id_47(lrc_no_white(),lrc_no_white()); };
parser_Cons : s_IDENT '(' parser_lParam  {$$ = Cgen_id_50(lrc_no_white(),$1,lrc_no_white(),lrc_no_white(),$3,lrc_no_white()); };
parser_Cons : '(' parser_lParam  {$$ = Cgen_id_49(lrc_no_white(),lrc_no_white(),$2,lrc_no_white()); };
parser_lParam : parser_Param parser_lParam  {$$ = Cgen_id_52(lrc_no_white(),$1,lrc_no_white(),$2,lrc_no_white()); };
parser_lParam : ')'  {$$ = Cgen_id_51(lrc_no_white(),lrc_no_white()); };
parser_Param : '{' s_IDENT ':' ':' parser_PType '}'  {$$ = Cgen_id_54(lrc_no_white(),lrc_no_white(),$2,lrc_no_white(),lrc_no_white(),lrc_no_white(),$5,lrc_no_white(),lrc_no_white()); };
parser_Param : parser_PType  {$$ = Cgen_id_53(lrc_no_white(),$1,lrc_no_white()); };
parser_PType : s_IDENT  {$$ = Cgen_id_63(lrc_no_white(),$1,lrc_no_white()); };
parser_PType : '(' parser_lFType '-' '>' parser_RFType  {$$ = Cgen_id_62(lrc_no_white(),lrc_no_white(),$2,lrc_no_white(),lrc_no_white(),lrc_no_white(),$5,lrc_no_white()); };
parser_PType : s_ANYTYPE  {$$ = Cgen_id_61(lrc_no_white(),$1,lrc_no_white()); };
parser_PType : s_CHAR  {$$ = Cgen_id_60(lrc_no_white(),$1,lrc_no_white()); };
parser_PType : s_INT  {$$ = Cgen_id_59(lrc_no_white(),$1,lrc_no_white()); };
parser_PType : s_PTR  {$$ = Cgen_id_58(lrc_no_white(),$1,lrc_no_white()); };
parser_PType : s_REAL  {$$ = Cgen_id_57(lrc_no_white(),$1,lrc_no_white()); };
parser_PType : s_BOOL  {$$ = Cgen_id_56(lrc_no_white(),$1,lrc_no_white()); };
parser_PType : s_STR  {$$ = Cgen_id_55(lrc_no_white(),$1,lrc_no_white()); };
parser_lFType : parser_FType parser_lFType  {$$ = Cgen_id_65(lrc_no_white(),$1,lrc_no_white(),$2,lrc_no_white()); };
parser_lFType : ')'  {$$ = Cgen_id_64(lrc_no_white(),lrc_no_white()); };
parser_FType : '(' parser_lFType '-' '>' parser_RFType  {$$ = Cgen_id_74(lrc_no_white(),lrc_no_white(),$2,lrc_no_white(),lrc_no_white(),lrc_no_white(),$5,lrc_no_white()); };
parser_FType : s_IDENT  {$$ = Cgen_id_73(lrc_no_white(),$1,lrc_no_white()); };
parser_FType : s_ANYTYPE  {$$ = Cgen_id_72(lrc_no_white(),$1,lrc_no_white()); };
parser_FType : s_CHAR  {$$ = Cgen_id_71(lrc_no_white(),$1,lrc_no_white()); };
parser_FType : s_INT  {$$ = Cgen_id_70(lrc_no_white(),$1,lrc_no_white()); };
parser_FType : s_PTR  {$$ = Cgen_id_69(lrc_no_white(),$1,lrc_no_white()); };
parser_FType : s_REAL  {$$ = Cgen_id_68(lrc_no_white(),$1,lrc_no_white()); };
parser_FType : s_BOOL  {$$ = Cgen_id_67(lrc_no_white(),$1,lrc_no_white()); };
parser_FType : s_STR  {$$ = Cgen_id_66(lrc_no_white(),$1,lrc_no_white()); };
parser_RFType : s_IDENT  {$$ = Cgen_id_82(lrc_no_white(),$1,lrc_no_white()); };
parser_RFType : s_ANYTYPE  {$$ = Cgen_id_81(lrc_no_white(),$1,lrc_no_white()); };
parser_RFType : s_CHAR  {$$ = Cgen_id_80(lrc_no_white(),$1,lrc_no_white()); };
parser_RFType : s_INT  {$$ = Cgen_id_79(lrc_no_white(),$1,lrc_no_white()); };
parser_RFType : s_PTR  {$$ = Cgen_id_78(lrc_no_white(),$1,lrc_no_white()); };
parser_RFType : s_REAL  {$$ = Cgen_id_77(lrc_no_white(),$1,lrc_no_white()); };
parser_RFType : s_BOOL  {$$ = Cgen_id_76(lrc_no_white(),$1,lrc_no_white()); };
parser_RFType : s_STR  {$$ = Cgen_id_75(lrc_no_white(),$1,lrc_no_white()); };
YYentry : FL_ENTRY parser_FL {lrc_parse_tree = Cgen_id_20($2); };
YYentry : FL_Cons_ENTRY parser_Cons {lrc_parse_tree = Cgen_id_27($2); };
YYentry : FL_Elem_ENTRY parser_Elem {lrc_parse_tree = Cgen_id_22($2); };
YYentry : FL_FType_ENTRY parser_FType {lrc_parse_tree = Cgen_id_33($2); };
YYentry : FL_Nterm_ENTRY parser_Nterm {lrc_parse_tree = Cgen_id_26($2); };
YYentry : FL_Option_ENTRY parser_Option {lrc_parse_tree = Cgen_id_23($2); };
YYentry : FL_PType_ENTRY parser_PType {lrc_parse_tree = Cgen_id_31($2); };
YYentry : FL_Param_ENTRY parser_Param {lrc_parse_tree = Cgen_id_30($2); };
YYentry : FL_RFType_ENTRY parser_RFType {lrc_parse_tree = Cgen_id_34($2); };
YYentry : FL_lCons_ENTRY parser_Sep {lrc_parse_tree = Cgen_id_28($2); };
YYentry : FL_lElem_ENTRY parser_lElem {lrc_parse_tree = Cgen_id_21($2); };
YYentry : FL_lFType_ENTRY parser_lFType {lrc_parse_tree = Cgen_id_32($2); };
YYentry : FL_lParam_ENTRY parser_lParam {lrc_parse_tree = Cgen_id_29($2); };
YYentry : BOOL_ENTRY parser_BoolOption {lrc_parse_tree = Cgen_id_25($2); };
%%
