/* init_tables */
extern void init_grammar_tables(void);
#ifdef V2C_CODE
extern void lrc_set_ip_attr(lrc_term *ip, char * name, lrc_term attr_value);
extern lrc_term lrc_get_op_attr(char * name, lrc_term *op);
#endif

/* visit */
extern void fill_visit_tables();

/* yacc_parser */
extern lrc_term lrc_parse_file(char * fname, int nt);
extern lrc_term lrc_parse_string(char * s, int nt);
extern void set_parse_debug(int n);

typedef int (*tp_f_token_convertor)(int,char *);
extern void define_token_convertor(tp_f_token_convertor convertor);

/* transformations */
#ifdef TRANSFORM
extern void lrc_define_transformations();
#endif


