#include <lrclib.h>

#define lrc_dummy_term C_Int(0)
#define lrc_nil_ptr lrc_dummy_term

#include "bcode.ttm"

#include "bcode.htc"

#include "bcode.hff"
#include "bcode.hsf"

#include "bcode.heq"
#include "bcode.deq"

#include "code.tbn"
#include "code.hbr"

#include "code.tvr"

#ifdef USER_ACTIONS
#include "visit_user.c"
#endif

void lrc_term_failure(char * vnt_proc_name, int err_tag) {
 printf("Wrong term in visit-routine %s; wrong tag is %d\n", 
                                       vnt_proc_name,err_tag);
 exit(1);
}

#define LRC_TERM_FAILURE(vntproc,err_tag) lrc_term_failure(vntproc,err_tag);

#include "code.hvr"
#include "code.ivr"

#include "code.siz"

#define LRC_DEFINE_VISIT(vpr_routine,global_number,prod_number,vis_number,num_ip_attrs,num_op_attrs)\
lrc_define_visit(vpr_routine,global_number,prod_number,vis_number,num_ip_attrs,num_op_attrs);

#define LRC_DEFINE_NONT_VISIT(vnt_routine,global_number,nont_number,visit_number,num_ip,num_op)\
lrc_define_nont_visit(vnt_routine,global_number,nont_number,visit_number,num_ip,num_op);

#define DEFINE_IN_PACKET_NAME(nt_num,vnum,attr_name,packet_index)\
  lrc_define_packet_attr(nt_num,vnum,attr_name,packet_index,1);
#define DEFINE_OUT_PACKET_NAME(nt_num,vnum,attr_name,packet_index)\
  lrc_define_packet_attr(nt_num,vnum,attr_name,packet_index,0);
static void lrc_define_visit_packet_attributes(void) {
#include "code.apk"
}


void fill_visit_tables() {
#include "code.vdf"
  lrc_define_visit_packet_attributes();
}

