#ifndef H_BINDING_EVENT
#define H_BINDING_EVENT
typedef enum { 
  EH_ERROR, EH_NOT_HANDLED, EH_REQUIRE_REPLACEMENT, EH_FULLY_HANDLED
} E_HANDLING_RESULT;

typedef struct eh_result {
  E_HANDLING_RESULT result_code;
  union {
    char *      mess;        /* error message */
    Replacement replacement; /* requested replacement */
  } result_value;
} EventHandlingResult;

int dt_handle_abstract_event(DecoratedTerm dt, lrc_term event, lrc_term frame);


#define NOT_CHANGED_TREE 0
#define CHANGED_TREE 1
#define NOT_HANDLED  0 
#define PARTIALLY_HANDLED (1<<1)
#define FULLY_HANDLED (1<<2)

#endif

