#ifndef H_DECORATION
#define H_DECORATION
typedef enum { NO_AST, NEW_BORN_AST, SAME_AS_PREV_AST, DIFF_FROM_PREV_AST } ast_state_tp;

typedef struct decorated_term {
  lrc_term ast;
  ast_state_tp ast_state;
  lrc_term * decoration;
  lrc_term derived_bindings;
} * DecoratedTerm;

DecoratedTerm create_decorated_term(void);
void          dt_enter_ast(DecoratedTerm dt, lrc_term abstract_tree);
lrc_term      dt_edse_initial_ast(DecoratedTerm dt);
void          dt_decorate_term(DecoratedTerm dt);
lrc_term *    dt_get_decoration(DecoratedTerm dt);
void          dt_install_root_attr(DecoratedTerm dt,lrc_term ast, lrc_term root_attr, char * name);

#endif

