#ifndef H_STRS
#define H_STRS
/*
** strs.h
** march 1994 by Maarten Pennings
** Library functions by Matthijs Kuiper
** generated from headers.noweb
*/

#include "memory.h"
#include "lrcmemory.h"
#include "chars.h"

typedef char * lrc_string; 

#define T__Str 4

  lrc_term C_Str(lrc_string);
       int lrc_string_compare(lrc_string,lrc_string);
       int lrc_string_compare_term(lrc_term, lrc_term);
  lrc_bool lrc_string_equal(lrc_string,lrc_string);
  lrc_bool lrc_string_equal_term(lrc_term, lrc_term);
      void lrc_string_print(lrc_string);

lrc_string lrc_string_const(lrc_string);
lrc_string lrc_string_concat(lrc_string,lrc_string);
lrc_string lrc_vstring_concat(lrc_string,...);
lrc_string lrc_string_sub(lrc_string,int,int);
lrc_string lrc_string_opensub(lrc_string,int);
      char lrc_string_index(lrc_string,int);

lrc_string lrc_string_default(void);

lrc_string lrc_string_copy(lrc_string);

void lrc_Str_init(void);
#endif

