typedef enum {
  unparse_open_command,
  unparse_child_command,
  unparse_skip_child_command,
  unparse_attr_command,
  unparse_str_command,
  unparse_chain_command_start,
  unparse_chain_command_end
} unparse_command_tp;

typedef struct {
  unparse_command_tp command;
  char * command_data;
} unparse_commands_entry_tp;

typedef unparse_commands_entry_tp unparse_commands_tp[];
typedef enum {
  view_entry_default,
  view_entry_normal,
  view_entry_list
} view_table_kind_tp;

typedef struct {
  view_table_kind_tp kind;
  int first_command_index;
  int num_commands;
} view_table_entry_tp;

typedef view_table_entry_tp view_prod_table_tp[];

typedef struct {
  char * view_name;
  view_prod_table_tp  * view_prod_table;
  unparse_commands_tp * view_unparse_commands;
} lrc_views_entry_tp;

typedef lrc_views_entry_tp lrc_views_tp[];

void unparse_term(lrc_term t, char * view_name, void printer(char *));


void f_unparse_term_with_attributes(FILE *f, lrc_term trm, char * view_name, lrc_term uals);
void unparse_term_with_attributes(lrc_term trm, char * view_name, lrc_term uals);



