/*
 * exemplo : Combinadores Html.
 */ 

# include <stdio.h>
# include <stdlib.h>
# include "HtmlComb.h"

# define verso(s) html_center(html_text(s))

int main(void)
{ HtmlLst poema ;
  Html    barra ;
  Html    titulo ;
  Html    vspace ;
  Html    autor ;
  Html    link ;
 
  titulo = html_bold(html_text("Perdidamente")); 
  vspace = html_br() ;
  autor  = html_italic(html_text("Florbela Espanca")) ;
  barra  = html_hline() ;
  link   = html_link ("http://www.uminho.pt",
                      html_text("Universidade do Minho")) ;

  poema = 
          ConsHtmlLst(verso("Ser poeta e ser mais alto, e ser maior\n")
        , ConsHtmlLst(verso("Do que os homens! Morder como quem beija!\n")
        , ConsHtmlLst(verso("E ser mendigo e dar como quem seja!")
        , ConsHtmlLst(verso("Rei do Reino de Aquem e de Alem Dor!")
        , ConsHtmlLst(vspace
        , ConsHtmlLst(verso("E ter mil desejos o esplendor")
        , ConsHtmlLst(verso("E nao saber sequer que se deseja!")
        , ConsHtmlLst(verso("E ter ca dentro um astro que flameja")
        , ConsHtmlLst(verso("E ter garras e asas de condor!")
        , ConsHtmlLst(vspace
        , ConsHtmlLst(verso("E ter fome, e ter sede de Infinito!")
        , ConsHtmlLst(verso("Por elmo, as manhas de oiro e de cetim...")
        , ConsHtmlLst(verso("E condensar o mundo num so grito!")
        , ConsHtmlLst(vspace
        , ConsHtmlLst(verso("E e amar-te, assim perdidamente...")
        , ConsHtmlLst(verso("E seres alma, e sangue, e vida em mim")
        , ConsHtmlLst(verso("E dize-lo cantando a toda gente!")
        , NoHtmlLst())))))))))))))))));          

  show(unparse_Html(titulo)) ;
  show(unparse_Html(barra)) ;
  show(unparse_HtmlLst(poema)) ;
  show(unparse_Html(barra)) ;
  show(unparse_Html(autor)) ;
  show(unparse_Html(vspace)) ;
  show(unparse_Html(link)) ;
  return 0;
};

