#ifndef H_MAP_OPERATIONS
#define H_MAP_OPERATIONS
#define map_ib_new(def) lrc_empty_map(lrc_int_equal_term,lrc_int_compare_term,lrc_bool_equal_term,lrc_bool_compare_term,C_Bool(def))
#define map_ii_new(def) lrc_empty_map(lrc_int_equal_term,lrc_int_compare_term,lrc_int_equal_term,lrc_int_compare_term,C_Int(def))
#define map_is_new(def) lrc_empty_map(lrc_int_equal_term,lrc_int_compare_term,lrc_string_equal_term,lrc_string_compare_term,C_Str(def))
#define map_si_new(def) lrc_empty_map(lrc_string_equal_term,lrc_string_compare_term,lrc_int_equal_term,lrc_int_compare_term,C_Int(def))
#define map_tb_new(def) lrc_empty_map(lrc_term_equal,LrcCompareTrees,lrc_bool_equal_term,lrc_bool_compare_term,C_Bool(def))
#define map_ti_new(def) lrc_empty_map(lrc_term_equal,LrcCompareTrees,lrc_int_equal_term,lrc_int_compare_term,C_Int(def))

lrc_bool   map_ib_apply(lrc_map map, int int_key);
int        map_ii_apply(lrc_map map, int int_key);
lrc_string map_is_apply(lrc_map map, int int_key);
int        map_si_apply(lrc_map map, lrc_string str_key);
lrc_bool   map_tb_apply(lrc_map map, lrc_term trm_key);
int        map_ti_apply(lrc_map map, lrc_term trm_key);
lrc_term   map_keys(lrc_map map, int bin_prod, int null_prod);
lrc_term   map_values(lrc_map map, int bin_prod, int null_prod);
lrc_term   map_map_values(lrc_map map, lrc_term f(), int bin_prod, int null_prod);

lrc_map map_ib_set(lrc_map map, int int_key, lrc_bool bool_val);
lrc_map map_ii_set(lrc_map map, int int_key, int int_val);
lrc_map map_is_set(lrc_map map, int int_key, lrc_string string_val);
lrc_map map_si_set(lrc_map map, lrc_string string_key, int int_val);
lrc_map map_ti_set(lrc_map map, lrc_term term_key, int int_val);
lrc_map map_tb_set(lrc_map map, lrc_term term_key, lrc_bool bool_val);

lrc_map lrc_map_default(void);
#endif

