#ifndef H_PRIMS
#define H_PRIMS
/*
** prims.h
** march 1994 by Maarten Pennings
** generated from headers.noweb
*/

#include "shalloc.h"

#define lrc_first_free_tag 9

void lrc_lib_init(void);
void lrc_lib_mark(void);
lrc_term lrc_list_append(int empty_tag, lrc_term l1, lrc_term l2);
#define lrc_ident(x) (x)

int LrcCompareTrees(lrc_term,lrc_term);
int lrc_primitive_compare(lrc_term, lrc_term);

int lrc_term_equal(lrc_term, lrc_term);
void lrc_dump_reset(void);

lrc_bool lrc_filter_true(lrc_term);

typedef void (*lrc_prim_print_function)(lrc_term);
void lrc_prim_print_address(lrc_term);
void lrc_prim_print_short(lrc_term);
void lrc_prim_print_untagged(lrc_term);
void lrc_prim_print_tagged(lrc_term);
void lrc_prim_print_install(lrc_prim_print_function);

typedef void (*lrc_term_print_function)(lrc_term);
void lrc_term_print_address(lrc_term);
void lrc_term_print_short(lrc_term);
void lrc_term_print_long(lrc_term);
void lrc_term_print_install(lrc_term_print_function);

void lrc_term_print_indent(lrc_term, int);
void lrc_term_fprint_indent(FILE * f, lrc_term t, int usr_indent_delta);

typedef lrc_term lrc_cell;
typedef void (*lrc_cell_print_function)(lrc_cell);
void lrc_cell_print_fipop(lrc_cell);
void lrc_cell_print_install(lrc_cell_print_function);

#endif

