#ifndef TEXTBUFFER_H
#define TEXTBUFFER_H
/* TEXTBUFFER */
typedef struct textbuffer {
  char *content;
  int size;  /* number of bytes in content */
  int free;  /* number of unused bytes in content */
} *Textbuffer;

Textbuffer textbuffer_init(void);
void       textbuffer_clear_content(Textbuffer tb);
void       textbuffer_store(Textbuffer,char *);
void       textbuffer_append(Textbuffer,char *);
void       textbuffer_append_char(Textbuffer tb, char c);
void       textbuffer_append_n_chars(Textbuffer tb, int n, char c);
int        textbuffer_used_size(Textbuffer tb);
#define    textbuffer_retrieve(tb) tb->content
#define    textbuffer_size(tb) tb->size

#endif
